//
//  ViewController.swift
//  TP2_classe_Personne
//
//  Created by Pierre Emmanuel Aguera on 19/06/2015.
//  Copyright (c) 2015 Pierre Emmanuel Aguera. All rights reserved.
//

import UIKit

class ViewController: UIViewController, UITextFieldDelegate {

  @IBOutlet weak var prenomTextField:UITextField?
  @IBOutlet weak var nomTextField:UITextField?
  @IBOutlet weak var nomCompletLabel:UILabel?
  @IBOutlet private weak var dateNaissancePicker:UIDatePicker?
  @IBOutlet private weak var dateLabel:UILabel?
  
  private var unePersonne=Personne()

  override func viewDidLoad() {
    super.viewDidLoad()
    // Do any additional setup after loading the view, typically from a nib.
    nomTextField!.delegate = self
    prenomTextField!.delegate = self
  }

  override func didReceiveMemoryWarning() {
    super.didReceiveMemoryWarning()
    // Dispose of any resources that can be recreated.
  }

  @IBAction func recupTextes(sender: AnyObject) {
    unePersonne.nom = nomTextField!.text
    unePersonne.prenom = prenomTextField!.text
    nomCompletLabel!.text = unePersonne.nomCompletMeth()
  }

  @IBAction func changeDate(sender: AnyObject) {
    // Récupération d'une référence sur le UIDatePicker
    let picker = sender as! UIDatePicker
    // Modification du label de date
    dateLabel!.text = "\(picker.date)"
    // Mise à jour du label de nom complet
    nomCompletLabel!.text = "\(unePersonne.nomCompletMeth()) \(picker.date)"
  }

  func textFieldDidEndEditing(textField: UITextField) {
    if (textField === nomTextField) {
      unePersonne.nom = nomTextField!.text
    } else if (textField === prenomTextField) {
      unePersonne.prenom = prenomTextField!.text
    } else {
      println("UITextField inconnu")
    }
    
    nomCompletLabel!.text = "\(unePersonne.nomCompletMeth()) \(dateNaissancePicker!.date)"
  }

}

