//
//  ViewController.swift
//  TP3-VuesProg
//
//  Created by Pierre Emmanuel Aguera on 23/06/2015.
//  Copyright (c) 2015 Pierre Emmanuel Aguera. All rights reserved.
//

import UIKit

class ViewController: UIViewController, UITextFieldDelegate {

  private var nomLabel:UILabel?
  private var prenomLabel:UILabel?
  private var prenomTextField:UITextField?
  private var nomTextField:UITextField?
  private var nomCompletLabel:UILabel?
  private var dateNaissancePicker:UIDatePicker?
  private var dateLabel:UILabel?
  private var recupBouton:UIButton?
  
  private var unePersonne:Personne?

  override func viewDidLoad() {
    super.viewDidLoad()
    // Do any additional setup after loading the view, typically from a nib.
    unePersonne = Personne()
    
    // Couleur de fond de la vue principale
    view.backgroundColor = UIColor.whiteColor()
    
    nomLabel = UILabel()
    nomLabel!.text = "Nom"
    view.addSubview(nomLabel!)
    
    nomTextField = UITextField()
    nomTextField!.text = ""
    nomTextField!.borderStyle = .RoundedRect
    nomTextField!.delegate = self
    view.addSubview(nomTextField!)

    prenomLabel = UILabel()
    prenomLabel!.text = "Prénom"
    view.addSubview(prenomLabel!)
    
    prenomTextField = UITextField()
    prenomTextField!.text = ""
    prenomTextField!.borderStyle = .RoundedRect
    prenomTextField!.delegate = self
    view.addSubview(prenomTextField!)

    nomCompletLabel = UILabel()
    nomCompletLabel!.text = ""
    view.addSubview(nomCompletLabel!)
    
    recupBouton = UIButton.buttonWithType(UIButtonType.System) as? UIButton
    recupBouton!.setTitle("Récupèrer", forState: .Normal)
    view.addSubview(recupBouton!)
    recupBouton!.addTarget(self, action: "recupTextes:", forControlEvents: .TouchDown)
    
    dateNaissancePicker = UIDatePicker()
    dateNaissancePicker!.datePickerMode = .Date
    view.addSubview(dateNaissancePicker!)
    dateNaissancePicker!.addTarget(self, action: "changeDate:", forControlEvents: .ValueChanged)
    
    dateLabel = UILabel()
    dateLabel!.text = ""
    view.addSubview(dateLabel!)
    
    // Tracé du contenu de la vue
    self.afficheContenu(UIScreen.mainScreen().bounds.size)
  }

  override func didReceiveMemoryWarning() {
    super.didReceiveMemoryWarning()
    // Dispose of any resources that can be recreated.
  }

  // Méthode d'affichage du contenu de la vue
  func afficheContenu(size:CGSize) {
    // Création des cadres du label et du champ de saisie du nom
    nomLabel!.frame = CGRectMake(15, 20, 50, 30);
    nomTextField!.frame = CGRectMake(15+50+5, 20, size.width-70-15, 30);
    // Création des cadres du label et du champ de saisie du prénom
    prenomLabel!.frame = CGRectMake(15, 20+30+5, 70, 30);
    prenomTextField!.frame = CGRectMake(15+70+5, 20+30+5, size.width-90-15, 30);
    // Création des cadres du label du nom complet
    nomCompletLabel!.frame = CGRectMake(15, 55+30+5, size.width-2*15, 30);
    // Création du cadre du bouton Récupèrer
    recupBouton!.frame = CGRectMake((size.width-100)*0.5, 85+30+5, 100, 40)
    // Création du cadre du DatePicker
    dateNaissancePicker!.frame = CGRectMake(15, 160+5, size.width-30, 215)
    // Création du cadre du label de date
    dateLabel!.frame = CGRectMake(15, 380+5, size.width-30, 30)
  }
  
  // Méthode de récupération des textes saisis par l'appui sur le bouton Récupérer
  func recupTextes(sender:AnyObject) {
    unePersonne!.nom = nomTextField!.text
    unePersonne!.prenom = prenomTextField!.text
    nomCompletLabel!.text = "\(unePersonne!.nomCompletMeth()) né le \(dateNaissancePicker!.date)"
  }

  // Méthode de récupération de la date du UIDatePicker (appelée lors du changement de valeur)
  func changeDate(sender:AnyObject) {
    dateLabel!.text = "\(dateNaissancePicker!.date)"
    // Mise à jour label nom complet avec date
    nomCompletLabel!.text = "\(unePersonne!.nomCompletMeth()) né le \(dateNaissancePicker!.date)"
  }

// MARK: Orientations
  override func shouldAutorotate() -> Bool {
    return true
  }
  
  override func supportedInterfaceOrientations()-> Int {
    return Int(UIInterfaceOrientationMask.All.rawValue)
  }
  
  override func viewWillTransitionToSize(size: CGSize, withTransitionCoordinator coordinator: UIViewControllerTransitionCoordinator) {
    self.afficheContenu(size)
  }

// MARK: UITextFiedlDelegate
  func textFieldDidEndEditing(textField: UITextField) {
    if (textField === nomTextField!) {
      unePersonne!.nom = textField.text
    } else if (textField === prenomTextField!) {
      unePersonne!.prenom = textField.text
    } else {
      println("ERREUR: textfield inconnu")
    }
    
    nomCompletLabel!.text = unePersonne!.nomCompletMeth()
  }
}

